---
title: Firefox 17 for developers
slug: Mozilla/Firefox/Releases/17
tags:
  - '17'
  - Firefox
---
<div>{{FirefoxSidebar}}</div>

<p>Firefox 17 shipped on November 20, 2012. This article lists key changes that are useful for not only web developers, but also Firefox and Gecko developers as well as add-on developers.</p>

<h2 id="Changes_for_Web_developers">Changes for Web developers</h2>

<h3 id="HTML">HTML</h3>

<ul>
 <li>Support for the {{htmlattrxref("sandbox", "iframe")}} attribute on the {{HTMLElement("iframe")}} element has been added. ({{bug("341604")}})</li>
</ul>

<h3 id="CSS">CSS</h3>

<ul>
 <li>Support for {{cssxref("@supports")}} at-rule defined in <a href="http://dev.w3.org/csswg/css3-conditional/">CSS3 Conditional Rules specification</a> has been landed. It is disabled by default. Developers can try it by setting <code>layout.css.supports-rule.enabled</code> to true (<a href="https://bugzilla.mozilla.org/show_bug.cgi?id=649740">bug 649740</a>).</li>
 <li>Support for the CSS Selectors Level 4 pseudo-class {{cssxref(":dir", ":dir()")}} allowing selection of elements based on their directionality has landed. (<a href="https://bugzilla.mozilla.org/show_bug.cgi?id=562169">bug 562169</a>)</li>
 <li>Support for the newly specified <code>isolate-override</code> value of the CSS {{cssxref("unicode-bidi")}} value has landed ({{bug("774335")}})</li>
 <li>Our prefixed implementation of {{cssxref("box-sizing")}} now takes into account {{cssxref("min-height")}} and {{cssxref("max-height")}}. One step closer to its unprefixing ({{bug("308801")}})</li>
</ul>

<h3 id="DOMAPIs">DOM/APIs</h3>

<ul>
 <li>Support for {{domxref("CSSSupportsRule")}} interface defined in <a href="http://dev.w3.org/csswg/css3-conditional/">CSS3 Conditional Rules specification</a> has been landed ({{bug("649740")}})</li>
 <li>Support for {{domxref("WheelEvent")}} object and <code>wheel</code> event have been landed ({{bug("719320")}}).</li>
 <li>Support DOM Meta key on Linux again ({{bug("751749")}}).</li>
 <li>On {{domxref("HTMLMediaElement")}}, a new method, <code>mozGetMetadata</code>, that returns a javascript object whose properties represent metadata from the playing media resource as {key: value} pairs ({{bug("763010")}}).</li>
 <li>Support for {{domxref("Range.intersectsNode")}} has been added again; it has been removed in Gecko 1.9 ({{bug("579638")}}.</li>
 <li>{{domxref("Range.compareBoundaryPoints()")}} now throws a {{domxref("DOMException")}} with the <code>NOT_SUPPORTED_ERR</code> value when the comparison method is invalid ({{bug("714279")}}) .</li>
 <li>{{domxref("Event.initEvent()")}} has been adapted to the spec: it doesn't throw anymore if called after the dispatch of the event, it is only a no-op ({{bug(768310)}}).</li>
 <li>The non-standard {{domxref("XMLHttpRequest", "XMLHttpRequest.onuploadrequest")}} property has been removed ({{bug(761278)}}).</li>
 <li>The method {{domxref("XMLHttpRequest.getAllResponseHeaders()")}} now separates them with a CRLF (instead of a LF), as requested by the spec ({{bug(730925)}}).</li>
</ul>

<h3 id="JavaScript">JavaScript</h3>

<ul>
 <li><a href="/en-US/docs/JavaScript/Reference/Global_Objects/String"><code>String</code></a> object now offers Harmony <a href="/en-US/docs/JavaScript/Reference/Global_Objects/String/startsWith" title="JavaScript/Reference/Global_Objects/String/startsWith"><code>startsWith</code></a>, <a href="/en-US/docs/JavaScript/Reference/Global_Objects/String/endsWith" title="JavaScript/Reference/Global_Objects/String/endsWith"><code>endsWith</code></a>, and <a href="/en-US/docs/JavaScript/Reference/Global_Objects/String/contains" title="JavaScript/Reference/Global_Objects/String/contains"><code>contains</code></a> methods ({{bug("772733")}}).</li>
 <li>The String methods <a href="/en-US/docs/JavaScript/Reference/Global_Objects/String/link" title="JavaScript/Reference/Global_Objects/String/link">link</a> and <a href="/en-US/docs/JavaScript/Reference/Global_Objects/String/anchor" title="JavaScript/Reference/Global_Objects/String/anchor">anchor</a> now escape the <code>'<strong>"</strong>'</code> (quotation mark) ({{bug("352437")}}).</li>
 <li>Experimental support for strawman <a href="/en-US/docs/JavaScript/Reference/Global_Objects/ParallelArray" title="JavaScript/Reference/Global_Objects/ParallelArray"><code>ParallelArray</code></a> object has been implemented ({{bug("778559")}}).</li>
 <li>Support to iterate <code><a href="/en-US/docs/JavaScript/Reference/Global_Objects/Map" title="JavaScript/Reference/Global_Objects/Map">Map</a></code>/<code><a href="/en-US/docs/JavaScript/Reference/Global_Objects/Set" title="JavaScript/Reference/Global_Objects/Set">Set</a></code> ({{bug("725909")}}).</li>
 <li>Disabled <a href="/en-US/docs/E4X" title="E4X">E4X</a> for web content by default ({{bug("778851")}}).</li>
 <li><code>__exposedProps__</code> must now be set for Chrome JavaScript objects exposed to content. Attempts to access Chrome objects from content without <code>__exposedProps__</code> set will fail silently ({{bug("553102")}}).</li>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Statements/for...of"><code>for..of</code></a> loops now work in terms of <code>.iterator()</code> and <code>.next()</code> ({{bug(725907)}}).</li>
</ul>

<h3 id="WebGL">WebGL</h3>

<ul>
 <li>The {{domxref("EXT_texture_filter_anisotropic")}} WebGL extension has been unprefixed. Using <code>"MOZ_EXT_texture_filter_anisotropic"</code> will present a warning from now on. The prefixed name is going to be removed in a future release ({{bug(776001)}}).</li>
</ul>

<h3 id="SVG">SVG</h3>

<p><em>No change.</em></p>

<h3 id="MathML">MathML</h3>

<ul>
 <li>The parsing of the <code>align</code> attribute on {{MathMLElement("mtable")}} elements has been updated to treat optional spaces more correctly.</li>
</ul>

<h3 id="XUL">XUL</h3>

<ul>
 <li>XUL <a href="/en-US/docs/XUL/key" title="XUL/key">key</a> element supports "os" modifier which is Win key (Super or Hyper key) ({{bug("778732")}}).</li>
</ul>

<h3 id="Network">Network</h3>

<ul>
 <li>Removed the non-standard feature <code>XMLHttpRequest.onuploadprogress</code> which was deprecaed in Firefox 14.</li>
</ul>

<p><em>No change.</em></p>

<h3 id="Developer_tools">Developer tools</h3>

<ul>
 <li>Change JSTerm's $ helper function from getElementById to querySelector() ({{bug("751749")}}).</li>
</ul>

<h3 id="User_Agent">User Agent</h3>

<p>The Gecko part of the user agent string changed. The build date (which hadn't been updated since 2010) was removed, and the Gecko version number was put in its place instead. So <code>Gecko/20100101</code> -&gt; <code>Gecko/17.0</code>. This may affect you if you are doing user agent sniffing.</p>

<h2 id="Changes_for_add-on_and_Mozilla_developers">Changes for add-on and Mozilla developers</h2>

<h3 id="Interface_changes">Interface changes</h3>

<dl>
 <dt>{{interface("nsIInputStream")}}</dt>
 <dd>The <code>available()</code> method returns 64-bit length instead of 32-bit ({{bug("215450")}}).</dd>
 <dt>{{interface("nsIDOMWindowUtils")}}</dt>
 <dd>The <code>sendMouseScrollEvent()</code> method has been replaced with <code>sendWheelEvent()</code> ({{bug("719320")}}).</dd>
 <dt>{{interface("nsIFilePicker")}}</dt>
 <dd>The <code>open()</code> method, to open the file dialog asynchronously, has been added and the <code>show()</code> method has been deprecated ({{bug("731307")}}).</dd>
 <dt>{{interface("nsIScriptSecurityManager")}}</dt>
 <dd>The <code>checkLoadURIStr()</code> and <code>checkLoadURI()</code> methods have been removed ({{bug("327244")}}).</dd>
 <dt>{{interface("nsIRefreshURI")}}</dt>
 <dd>The <code>setupRefreshURIFromHeader()</code> method has a added <code>principal</code> parameter ({{bug("327244")}}).</dd>
</dl>

<h4 id="New_interfaces">New interfaces</h4>

<p><em>None.</em></p>

<h4 id="Removed_interfaces">Removed interfaces</h4>

<p><em>None removed.</em></p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="http://www.mozilla.org/en-US/firefox/17.0/releasenotes/">Firefox 17 Release Notes</a></li>
 <li><a href="https://hacks.mozilla.org/2012/08/aurora-17-is-out/">Aurora 17 is out, bringing better security and support for new standards</a> (Mozilla Hacks)</li>
 <li><a href="https://www.fxsitecompat.com/en-US/versions/17/">Site Compatibility for Firefox 17</a></li>
 <li><a href="https://blog.mozilla.org/addons/2012/11/08/compatibility-for-firefox-17/">Add-on Compatibility for Firefox 17</a> (Add-ons Blog)</li>
</ul>

<h3 id="Older_versions">Older versions</h3>

<div>{{Firefox_for_developers('16')}}</div>
